#include "fdf.h"

void	fill_row(t_list **list, int i, char *row)
{
	int		j;
	char 	**row_numbers;
	t_vec	vec3;

	j = 0;
	vec3.y = i;
	row_numbers = ft_strsplit(row, ' ');
	while (row_numbers[j])
	{
		vec3.x = j;
		vec3.z = ft_atoi(row_numbers[j]);
		ft_lstadd_back(list, &vec3, sizeof(t_vec));
		j++;
	}
	free_tab(row_numbers);
}

t_list	*to_lst_map(char **tab_map)
{
	int 	i;
	t_list	*lst_map;

	lst_map = NULL;
	i = 0;
	while (tab_map[i])
	{
		fill_row(&lst_map, i, tab_map[i]);
		i++;
	}
	return (lst_map);
}

char	*to_str_map(char *path)
{
	int 	fd;

	fd = open(path, O_RDONLY);
	if (fd != -1)
		return (ft_read_file(fd));
	return (0);
}

int 	tab_length(char **tab)
{
	int 	len;

	len = 0;
	while (*tab)
	{
		tab++;
		if (*tab)
			len++;
	}
	return (len);
}

int 	map_width(char **tab)
{
	int 	width;
	char 	**line_tab;

	line_tab = ft_strsplit(*tab, ' ');
	width =	tab_length(line_tab);
	free_tab(line_tab);
	return (width);
}


void	min_max_z(t_map *map, int i, int j)
{
	if (map->arr_vec[i][j].z > map->z_max)
		map->z_max = map->arr_vec[i][j].z;
	if (map->arr_vec[i][j].z < map->z_max)
		map->z_min = map->arr_vec[i][j].z;
}

void	to_vec_arr(char **tab, t_map *map)
{
	char 	**line;
	int 	i;
	int 	j;

	map->y_max = tab_length(tab);
	map->x_max = map_width(tab);
	map->arr_vec = malloc(sizeof(t_vec *) * (map->y_max + 1));
	i = 0;
	while (i <= map->y_max)
	{
		j = 0;
		line = ft_strsplit(tab[i], ' ');
		map->arr_vec[i] = malloc(sizeof(t_vec) * (map->x_max + 1));
		while (j <= map->x_max)
		{
			map->arr_vec[i][j].z = ft_atoi(line[j]);
			map->arr_vec[i][j].x = j;
			map->arr_vec[i][j].y = i;
			min_max_z(map, i, j);
			j++;
		}
		free_tab(line);
		i++;
	}
}

t_map	*map_init(char *path)
{
	char 	*str_map;
	char 	**tab_map;
	t_map	*map;

	map = malloc(sizeof(t_map));
	map->z_min = 0;
	map->x_max = 0;
	if (!(str_map = to_str_map(path)))
	{
		ft_putstr("Wrong path to a map! For help help put \"fdf --help\"");
		quit(0);
	}
	tab_map = ft_strsplit(str_map, '\n');
	to_vec_arr(tab_map, map);
	free(str_map);
	free_tab(tab_map);
	return (map);
}